package kz.arta.synergy.workflow.mobile.android.documents.offline.actions;

import android.content.ContentValues;
import android.content.Context;
import android.database.Cursor;
import android.database.sqlite.SQLiteDatabase;
import android.database.sqlite.SQLiteOpenHelper;

import java.util.ArrayList;
import java.util.List;

import kz.arta.synergy.workflow.mobile.android.common.models.offline.OfflineEditComment;

/**
 * Created by neox on 26.08.16.
 */
public class DocumentEditCommentTable extends SQLiteOpenHelper {

    private SQLiteDatabase db = getWritableDatabase();
    private static final String TABLE_NAME = "DocumentEditCommentTable";
    private static final String TABLE = "create table " + TABLE_NAME + " ("
            + "documentID text,"
            + "commentID text,"
            + "comment text,"
            + "name text"
            + ");";

    public DocumentEditCommentTable(Context context) {
        super(context, TABLE_NAME, null, 1);
    }

    @Override
    public void onCreate(SQLiteDatabase sqLiteDatabase) {
        sqLiteDatabase.execSQL(TABLE);
    }

    @Override
    public void onUpgrade(SQLiteDatabase sqLiteDatabase, int i, int i2) {

    }

    public boolean removeAll() {
        try {
            db.delete(TABLE_NAME, null, null);
            return true;
        } catch (Exception exc) {
            return false;
        }
    }

    public boolean add(String documentID, String commentID, String comment, String name) {
        try {
            db.delete(TABLE_NAME, "commentID = ?", new String[]{commentID});
            ContentValues cv = new ContentValues();
            cv.put("documentID", documentID);
            cv.put("commentID", commentID);
            cv.put("comment", comment);
            cv.put("name", name);
            db.insert(TABLE_NAME, null, cv);
            return true;
        } catch (Exception exc) {
            return false;
        }
    }

    public List<OfflineEditComment> get() {
        List<OfflineEditComment> result = new ArrayList<>();
        Cursor c = null;
        try {
            c = db.query(TABLE_NAME, null, null, null, null, null, null);
            if (c.moveToFirst()) {
                do {
                    OfflineEditComment item = new OfflineEditComment();
                    item.setActionID(c.getString(c.getColumnIndex("documentID")));
                    item.setCommentID(c.getString(c.getColumnIndex("commentID")));
                    item.setComment(c.getString(c.getColumnIndex("comment")));
                    item.setName(c.getString(c.getColumnIndex("name")));
                    result.add(item);
                } while (c.moveToNext());
            }
            return result;
        } catch (Exception exc) {
            return result;
        } finally {
            if (c != null) {
                c.close();
            }
        }
    }
}
